////////////////////////////////////////////////////////
//
// SourceMod Script
//
// DoD FieldMedic
//
// Developed by FeuerSturm for the Realism Community!
//
////////////////////////////////////////////////////////
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

#define PLUGIN_VERSION "1.4"

public Plugin:myinfo = 
{
	name = "DoD FieldMedic",
	author = "FeuerSturm",
	description = "Deploy a FieldMedic to the battlefield!",
	version = PLUGIN_VERSION,
	url = "http://www.dodsourceplugins.net"
}

#define MAXENTITIES 1024
#define FIELDMEDIC	1
#define ALLIES		2
#define AXIS		3


new String:g_MediKit_Model[] = { "models/props_misc/ration_box01.mdl" }
new String:g_MediKit_Sound[] = { "object/object_taken.wav" }
new String:g_FieldMedicModel[4][] = { "", "", "models/player/medic/medic_american/medic_american.mdl", "models/player/medic/medic_german/medic_german.mdl" }

new g_MediKit_Skin[4] = { 0, 0, 2, 1 }
new g_MediKits[MAXPLAYERS+1]
new Float:g_LastDrop[MAXPLAYERS+1]
new Float:g_LastCall[MAXPLAYERS+1]
new bool:isMedic[MAXPLAYERS+1]
new g_SelfMedic[MAXPLAYERS+1]

new Handle:FMStatus = INVALID_HANDLE
new Handle:FMWeaponSet = INVALID_HANDLE
new Handle:FMMedicCount = INVALID_HANDLE
new Handle:FMPlayerMaxHp = INVALID_HANDLE
new Handle:FMPlayerSelfHeal = INVALID_HANDLE
new Handle:FMPlayerSelfHealKits = INVALID_HANDLE
new Handle:FMMedicMaxHp = INVALID_HANDLE
new Handle:FMMedicPistolClips = INVALID_HANDLE
new Handle:FMMedicSmokeCount = INVALID_HANDLE
new Handle:FMMedicRegenHealth = INVALID_HANDLE
new Handle:FMMedicRegenStamina = INVALID_HANDLE
new Handle:FMPlayerCallMaxHp = INVALID_HANDLE
new Handle:FMMediKitHealth = INVALID_HANDLE
new Handle:FMMediKitLifeTime = INVALID_HANDLE
new Handle:FMMediKitCount = INVALID_HANDLE
new Handle:FMMediKitMaxCount = INVALID_HANDLE
new Handle:FMMediKitVelocity = INVALID_HANDLE
new Handle:FMMediKitDropDelay = INVALID_HANDLE

new String:WpnPistol[4][] = { "weapon_m1carbine", "weapon_c96", "weapon_colt", "weapon_p38" }
new String:WpnSmokeGrenade[4][] = { "", "", "weapon_smoke_us", "weapon_smoke_ger" }
new PistolOffset[4] = { 24, 12, 4, 8 }
new PistolAmmo[4] = { 15, 20, 7, 8 }
new SmokeGrenadeOffset[4] = { 0, 0, 68, 72 }
new String:g_Melee[4][] = { "", "", "weapon_amerknife", "weapon_spade" }
new ammo_offset
new m_hMyWeapons = 0

public OnPluginStart()
{
	CreateConVar("dod_fieldmedic_version", PLUGIN_VERSION, "DoD FieldMedic Version (DO NOT CHANGE!)", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_NOTIFY)
	SetConVarString(FindConVar("dod_fieldmedic_version"), PLUGIN_VERSION)
	FMStatus = CreateConVar("dod_fieldmedic_enabled", "1", "<1/0> = enable/disable the FieldMedic plugin", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	FMMedicCount = CreateConVar("dod_fieldmedic_mediccount", "2", "<#> = Number of FieldMedics allowed per team", FCVAR_PLUGIN, true, 1.0, true, 5.0)
	FMPlayerMaxHp = CreateConVar("dod_fieldmedic_playermaxhp", "100", "<#> = Maximum Health a player can be healed to", FCVAR_PLUGIN, true, 40.0, true, 100.0)
	FMPlayerSelfHeal = CreateConVar("dod_fieldmedic_playercanselfheal", "1", "<1/0> = allow/disallow players to self heal when no medic is alive", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	FMPlayerSelfHealKits = CreateConVar("dod_fieldmedic_playerselfhealkits", "1", "<#> = number of times players can self heal if no medic is alive", FCVAR_PLUGIN, true, 1.0, true, 5.0)
	FMMedicMaxHp = CreateConVar("dod_fieldmedic_medicmaxhp", "100", "<#> = Maximum Health a Medic can regenerate to", FCVAR_PLUGIN, true, 40.0, true, 100.0)
	FMMedicPistolClips = CreateConVar("dod_fieldmedic_medicpistolclips", "10", "<#> = Number of pistol mags for the Medic", FCVAR_PLUGIN, true, 3.0, true, 20.0)
	FMMedicSmokeCount = CreateConVar("dod_fieldmedic_medicsmokecount", "3", "<#> = Number of smoke grenades for the Medic", FCVAR_PLUGIN, true, 1.0, true, 5.0)
	FMMedicRegenHealth = CreateConVar("dod_fieldmedic_medicregenhealth", "2", "<#> = Health the Medic regenerates per second after being hurt", FCVAR_PLUGIN, true, 1.0, true, 5.0)
	FMMedicRegenStamina = CreateConVar("dod_fieldmedic_medicregenstamina", "10", "<#> = Stamina the Medic regenerates per second while sprinting", FCVAR_PLUGIN, true, 5.0, true, 25.0)
	FMPlayerCallMaxHp = CreateConVar("dod_fieldmedic_playercallmaxhp", "60", "<#> = Health left after that a player can call a Medic", FCVAR_PLUGIN, true, 1.0, true, 99.0)
	FMMediKitHealth = CreateConVar("dod_fieldmedic_kithealth", "25", "<#> = Health a player regains by picking up a MediKit", FCVAR_PLUGIN, true, 10.0, true, 50.0)
	FMMediKitLifeTime = CreateConVar("dod_fieldmedic_kitlifetime", "15", "<#> = Time in seconds dropped MediKits stay available on the map", FCVAR_PLUGIN, true, 5.0, true, 45.0)
	FMMediKitCount = CreateConVar("dod_fieldmedic_kitcount", "10", "<#> = Amount of MediKits a FieldMedic spawns with", FCVAR_PLUGIN, true, 5.0, true, 20.0)
	FMMediKitMaxCount = CreateConVar("dod_fieldmedic_kitmaxcount", "15", "<#> = Amount of MediKits a FieldMedic can have including picking others' up", FCVAR_PLUGIN, true, 5.0, true, 25.0)
	FMMediKitVelocity = CreateConVar("dod_fieldmedic_kitvelocity", "450", "<#> = Velocity of MediKits when dropping (higher value = flying wider)", FCVAR_PLUGIN, true, 350.0, true, 700.0)
	FMMediKitDropDelay = CreateConVar("dod_fieldmedic_kitdropdelay", "2", "<#> = Time in seconds before a Medic can drop another MediKit", FCVAR_PLUGIN, true, 1.0, true, 5.0)
	FMWeaponSet = CreateConVar("dod_fieldmedic_weaponset", "0", "<0/1> = set FieldMedic's weaponset - 1=Colt/P38 - 2=Carbine/C96", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	RegAdminCmd("dropammo", cmdDropMediKit, 0)
	RegAdminCmd("sm_medic", cmdCallMedic, 0)
	HookEvent("player_hurt", OnPlayerDeath, EventHookMode_Pre)
	HookEventEx("player_spawn", OnPlayerSpawn, EventHookMode_Post)
	HookEventEx("player_team", OnPlayerStatus, EventHookMode_Post)
	HookEventEx("player_changeclass", OnPlayerStatus, EventHookMode_Post)
	AutoExecConfig(true,"dod_fieldmedic", "dod_fieldmedic")
}

public OnMapStart()
{
	AddFileToDownloadsTable("models/player/medic/medic_american/medic_american.dx80.vtx")
	AddFileToDownloadsTable("models/player/medic/medic_american/medic_american.dx90.vtx")
	AddFileToDownloadsTable("models/player/medic/medic_american/medic_american.mdl")
	AddFileToDownloadsTable("models/player/medic/medic_american/medic_american.phy")
	AddFileToDownloadsTable("models/player/medic/medic_american/medic_american.sw.vtx")
	AddFileToDownloadsTable("models/player/medic/medic_american/medic_american.vvd")
	AddFileToDownloadsTable("models/player/medic/medic_german/medic_german.dx80.vtx")
	AddFileToDownloadsTable("models/player/medic/medic_german/medic_german.dx90.vtx")
	AddFileToDownloadsTable("models/player/medic/medic_german/medic_german.mdl")
	AddFileToDownloadsTable("models/player/medic/medic_german/medic_german.phy")
	AddFileToDownloadsTable("models/player/medic/medic_german/medic_german.sw.vtx")
	AddFileToDownloadsTable("models/player/medic/medic_german/medic_german.vvd")
	AddFileToDownloadsTable("materials/models/player/medic/medic_american/american_body.vmt")
	AddFileToDownloadsTable("materials/models/player/medic/medic_american/american_body.vtf")
	AddFileToDownloadsTable("materials/models/player/medic/medic_american/american_gear.vmt")
	AddFileToDownloadsTable("materials/models/player/medic/medic_american/american_gear.vtf")
	AddFileToDownloadsTable("materials/models/player/medic/medic_german/german_body.vmt")
	AddFileToDownloadsTable("materials/models/player/medic/medic_german/german_body.vtf")
	AddFileToDownloadsTable("materials/models/player/medic/medic_german/german_gear.vmt")
	AddFileToDownloadsTable("materials/models/player/medic/medic_german/german_gear.vtf")	
	PrecacheModel(g_FieldMedicModel[ALLIES], true)
	PrecacheModel(g_FieldMedicModel[AXIS], true)
	PrecacheModel(g_MediKit_Model, true)
	PrecacheSound(g_MediKit_Sound, true)
	ammo_offset = FindSendPropOffs("CDODPlayer", "m_iAmmo")
	m_hMyWeapons = FindSendPropOffs("CDODPlayer", "m_hMyWeapons")
}

public OnClientPutInServer(client)
{
	isMedic[client] = false
	g_MediKits[client] = 0
	g_SelfMedic[client] = 0
	g_LastDrop[client] = GetGameTime()
	g_LastCall[client] = GetGameTime()
	SDKHook(client, SDKHook_WeaponCanUse, OnWeaponCanUse)
}

public Action:OnPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Continue
	}
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		if(GetClientMenu(client))
		{
			CancelClientMenu(client)
		}
		isMedic[client] = false
		g_MediKits[client] = 0
		g_SelfMedic[client] = GetConVarInt(FMPlayerSelfHealKits)
		new team = GetClientTeam(client)
		if(team >= ALLIES)
		{
			new iPlayerClass = GetEntProp(client, Prop_Send, "m_iPlayerClass")
			if(iPlayerClass == FIELDMEDIC)
			{
				CreateTimer(0.1, SelectFieldMedic, client, TIMER_FLAG_NO_MAPCHANGE)
			}
		}
	}
	return Plugin_Continue
}

public Action:OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Continue
	}
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	if(GetClientHealth(client) > 0 || !IsClientInGame(client))
	{
		return Plugin_Continue
	}
	if(g_MediKits[client] == 0 || !isMedic[client])
	{
		isMedic[client] = false
		return Plugin_Continue
	}
	new Float:deathorigin[3]
	GetClientAbsOrigin(client,deathorigin)
	deathorigin[2] += 5.0
	new team = GetClientTeam(client)
	new MediKit = CreateEntityByName("prop_physics_override")
	SetEntityModel(MediKit,g_MediKit_Model)
	SetEntProp(MediKit, Prop_Send, "m_nSkin", g_MediKit_Skin[team])
	DispatchSpawn(MediKit)
	TeleportEntity(MediKit, deathorigin, NULL_VECTOR, NULL_VECTOR)
	SDKHook(MediKit, SDKHook_Touch, OnMediKitTouched)
	killEntityIn(MediKit, GetConVarFloat(FMMediKitLifeTime))
	isMedic[client] = false
	return Plugin_Continue
}

public Action:OnPlayerStatus(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	if(client < 1 || client > MaxClients || !IsClientInGame(client))
	{
		return Plugin_Continue
	}
	if(!IsPlayerAlive(client))
	{
		isMedic[client] = false
	}
	return Plugin_Continue
}

public Action:OnMediKitTouched(MediKit, client)
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Continue
	}
	if(client > 0 && client <= MaxClients && IsClientInGame(client) && IsPlayerAlive(client))
	{
		new iPlayerClass = GetEntProp(client, Prop_Send, "m_iPlayerClass")
		if(iPlayerClass == FIELDMEDIC && isMedic[client])
		{
			if(g_MediKits[client] >= GetConVarInt(FMMediKitMaxCount) || g_LastDrop[client] + 0.5 > GetGameTime())
			{
				return Plugin_Continue
			}
			PlayPickUpSound(client)
			AcceptEntityInput(MediKit, "kill")
			g_MediKits[client]++
			PrintToChat(client, "\x04[DoD FieldMedic] \x01You have \x05%i \x01MediKits left!", g_MediKits[client])
			return Plugin_Continue
		}
		new health = GetClientHealth(client)
		new maxhealth = GetConVarInt(FMPlayerMaxHp)
		if(health >= maxhealth)
		{
			return Plugin_Continue
		}
		new MediKitadd = GetConVarInt(FMMediKitHealth)
		SetEntityHealth(client, health + MediKitadd >= maxhealth ? maxhealth : health + MediKitadd)
		PlayPickUpSound(client)
		AcceptEntityInput(MediKit, "kill")
	}
	return Plugin_Continue
}

public Action:OnWeaponCanUse(client, weapon)
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Continue
	}
	new iPlayerClass = GetEntProp(client, Prop_Send, "m_iPlayerClass")
	if(iPlayerClass == FIELDMEDIC && isMedic[client])
	{
		decl String:sWeapon[32]
		GetEdictClassname(weapon, sWeapon, sizeof(sWeapon))
		if(StrEqual(sWeapon, "weapon_colt") || StrEqual(sWeapon, "weapon_amerknife") || StrEqual(sWeapon, "weapon_spade") || StrEqual(sWeapon, "weapon_p38") || StrEqual(sWeapon, "weapon_smoke_us") || StrEqual(sWeapon, "weapon_smoke_ger") || StrEqual(sWeapon, "weapon_basebomb") || StrEqual(sWeapon, "weapon_m1carbine") || StrEqual(sWeapon, "weapon_c96") || StrContains(sWeapon, "_live", true) != -1)
		{
			return Plugin_Continue
		}
		return Plugin_Handled
	}
	return Plugin_Continue
}

public Action:cmdCallMedic(client,args)
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Continue
	}
	if(client < 1 || client > MaxClients || !IsClientInGame(client) || !IsPlayerAlive(client))
	{
		return Plugin_Handled
	}
	if(isMedic[client])
	{
		PrintToChat(client, "\x04[DoD FieldMedic] \x01Sorry, you ARE a Medic, you don't need one!")
		return Plugin_Handled
	}
	new health = GetClientHealth(client)
	if(health >= GetConVarInt(FMPlayerCallMaxHp))
	{
		PrintToChat(client, "\x04[DoD FieldMedic] \x01Sorry, you don't need a medic, you're fine!")
		return Plugin_Handled
	}
	new team = GetClientTeam(client)
	new medics = 0
	for(new i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) == team && isMedic[i])
		{
			medics++
			if(g_LastCall[client] + 5.0 < GetGameTime())
			{
				PrintToChat(i, "\x04[DoD FieldMedic] \x01Soldier \x05%N \x01(\x05%ihp\x01) is calling for Medic!", client, health)
			}
		}
	}
	if(medics > 0)
	{
		if(g_LastCall[client] + 5.0 < GetGameTime())
		{
			FakeClientCommandEx(client, "voice_medic")
			PrintToChat(client, "\x04[DoD FieldMedic] \x01A FieldMedic has been alerted, hold on!")
			g_LastCall[client] = GetGameTime()
			return Plugin_Handled
		}
		else
		{
			PrintToChat(client, "\x04[DoD FieldMedic] \x01You already called for a Medic!")
			return Plugin_Handled
		}
	}
	else
	{
		if(GetConVarInt(FMPlayerSelfHeal) == 1)
		{
			if(g_SelfMedic[client] <= 0)
			{
				PrintToChat(client, "\x04[DoD FieldMedic] \x01Sorry, you already used your FirstAid Kits!")
				return Plugin_Handled
			}
			FakeClientCommandEx(client, "voice_medic")
			new MediKitadd = GetConVarInt(FMMediKitHealth)
			new maxhealth = GetConVarInt(FMPlayerMaxHp)
			SetEntityHealth(client, health + MediKitadd >= maxhealth ? maxhealth : health + MediKitadd)
			PlayPickUpSound(client)
			g_SelfMedic[client]--
			PrintToChat(client, "\x04[DoD FieldMedic] \x01You bandaged yourself, \x05%i \x01FirstAid Kits left!", g_SelfMedic[client])
			return Plugin_Handled
		}
		else
		{
			PrintToChat(client, "\x04[DoD FieldMedic] \x01Sorry, there's no FieldMedic alive!")
		}
	}
	return Plugin_Handled
}

public Action:cmdDropMediKit(client, args) 
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Continue
	}
	if(!IsPlayerAlive(client) || !IsClientInGame(client) || GetClientTeam(client) < ALLIES)
	{
		return Plugin_Continue
	}
	new iPlayerClass = GetEntProp(client, Prop_Send, "m_iPlayerClass")
	if(iPlayerClass == FIELDMEDIC && isMedic[client])
	{
		if(g_MediKits[client] != 0 && g_LastDrop[client] + GetConVarFloat(FMMediKitDropDelay) < GetGameTime())
		{
			new Float:origin[3]
			GetClientAbsOrigin(client, origin)
			origin[2] += 55.0
			new Float:angles[3]
			GetClientEyeAngles(client, angles)
			new Float:velocity[3]
			GetAngleVectors(angles, velocity, NULL_VECTOR, NULL_VECTOR)
			NormalizeVector(velocity, velocity)
			ScaleVector(velocity, GetConVarFloat(FMMediKitVelocity))
			new team = GetClientTeam(client)
			new MediKit = CreateEntityByName("prop_physics_override")
			SetEntityModel(MediKit,g_MediKit_Model)
			SetEntProp(MediKit, Prop_Send, "m_nSkin", g_MediKit_Skin[team])
			DispatchSpawn(MediKit)
			TeleportEntity(MediKit, origin, angles, velocity)
			SDKHook(MediKit, SDKHook_Touch, OnMediKitTouched)
			killEntityIn(MediKit, GetConVarFloat(FMMediKitLifeTime))
			g_MediKits[client]--
			PrintToChat(client, "\x04[DoD FieldMedic] \x01You have \x05%i \x01MediKits left!", g_MediKits[client])
			g_LastDrop[client] = GetGameTime()
		}
		return Plugin_Handled
	}
	return Plugin_Continue
}

public Action:SelectFieldMedic(Handle:timer, any:client)
{
	new Handle:FieldMedicMenu = CreateMenu(Handle_FieldMedicMenu)
	decl String:menutitle[256]
	Format(menutitle, sizeof(menutitle), "Select your Class!")
	SetMenuTitle(FieldMedicMenu, menutitle)
	AddMenuItem(FieldMedicMenu, "Assault", "Default Assault Class")
	AddMenuItem(FieldMedicMenu, "Medic", "FieldMedic Class")
	SetMenuExitButton(FieldMedicMenu, false)
	SetMenuExitBackButton(FieldMedicMenu, false)
	DisplayMenu(FieldMedicMenu, client, 5)
	return Plugin_Handled
}

public Handle_FieldMedicMenu(Handle:FieldMedicMenu, MenuAction:action, client, itemNum)
{
	if(action == MenuAction_Select)
	{
		new iPlayerClass = GetEntProp(client, Prop_Send, "m_iPlayerClass")
		if(iPlayerClass == FIELDMEDIC)
		{
			new String:SelectedClass[7]
			GetMenuItem(FieldMedicMenu, itemNum, SelectedClass, sizeof(SelectedClass))
			if(StrEqual(SelectedClass, "Medic"))
			{
				new team = GetClientTeam(client)
				new medics = 0
				for(new i = 1; i <= MaxClients; i++)
				{
					if(IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) == team && isMedic[i])
					{
						medics++
					}
				}
				new maxmedics = GetConVarInt(FMMedicCount)
				if(medics >= maxmedics)
				{
					PrintToChat(client, "\x04[DoD FieldMedic] \x01Sorry, there's already %i %s!", maxmedics, maxmedics > 1 ? "Medics" : "Medic")
				}
				else
				{
					g_MediKits[client] = GetConVarInt(FMMediKitCount)
					g_SelfMedic[client] = 0
					SetEntityModel(client, g_FieldMedicModel[team])
					CreateTimer(0.15, AdjustInventory, client, TIMER_FLAG_NO_MAPCHANGE)
					PrintToChat(client, "\x04[DoD FieldMedic] \x01You are a FieldMedic now!")
					PrintToChat(client, "\x04[DoD FieldMedic] \x01You can drop \x05%i \x01MediKits by pressing your '\x05dropammo\x01'-key!", g_MediKits[client])
				}
			}
		}
	}
}

public Action:AdjustInventory(Handle:timer, any:client)
{
	new team = GetClientTeam(client)
	if(IsClientInGame(client) && IsPlayerAlive(client) && team > 1)
	{
		if(StripWeapons(client))
		{
			isMedic[client] = true
			GivePlayerItem(client, WpnSmokeGrenade[team])
			SetEntData(client, ammo_offset+SmokeGrenadeOffset[team], GetConVarInt(FMMedicSmokeCount), 4, true)
			GivePlayerItem(client, g_Melee[team])
			if(GetConVarInt(FMWeaponSet) == 1)
			{
				team -= 2
			}
			new clips = GetConVarInt(FMMedicPistolClips) * PistolAmmo[team]
			GivePlayerItem(client, WpnPistol[team])
			SetEntData(client, ammo_offset+PistolOffset[team], clips, 4, true)
			CreateTimer(1.0, MedicRegenerate, client, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE)
		}
	}
	return Plugin_Handled
}

bool:StripWeapons(client)
{
	static WeaponOffs = 0, WeaponEntId = 0
	for (WeaponOffs = 0; WeaponOffs <= (47 * 4); WeaponOffs += 4)
	{
		WeaponEntId = GetEntDataEnt2(client, (m_hMyWeapons + WeaponOffs))
		if (WeaponEntId && IsValidEdict(WeaponEntId))
		{
			RemovePlayerItem(client, WeaponEntId)
			AcceptEntityInput(WeaponEntId, "kill")
		}
	}
	return true
}

public Action:MedicRegenerate(Handle:timer, any:client)
{
	if(GetConVarInt(FMStatus) == 0)
	{
		return Plugin_Stop
	}
	if(IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) > 1)
	{
		new iPlayerClass = GetEntProp(client, Prop_Send, "m_iPlayerClass")
		if(iPlayerClass != FIELDMEDIC || !isMedic[client])
		{
			return Plugin_Stop
		}
		new Health = GetClientHealth(client)
		new RegenHp = GetConVarInt(FMMedicRegenHealth)
		if(Health + RegenHp <= GetConVarInt(FMMedicMaxHp))
		{
			SetEntityHealth(client, Health + RegenHp)
		}
		new Float:Stamina = GetEntPropFloat(client, Prop_Send, "m_flStamina")
		new Float:RegenStamina = GetConVarFloat(FMMedicRegenStamina)
		if(Stamina + RegenStamina <= 100.0)
		{
			SetEntPropFloat(client, Prop_Send, "m_flStamina", Stamina + RegenStamina)
		}
		return Plugin_Handled
	}
	return Plugin_Stop
}

public killEntityIn(entity, Float:seconds)
{
	if(IsValidEdict(entity))
	{
		new String:addoutput[64]
		Format(addoutput, sizeof(addoutput), "OnUser1 !self:kill::%f:1",seconds)
		SetVariantString(addoutput)
		AcceptEntityInput(entity, "AddOutput")
		AcceptEntityInput(entity, "FireUser1")
	}
}

stock PlayPickUpSound(client)
{
	EmitSoundToClient(client, g_MediKit_Sound, SOUND_FROM_PLAYER,SNDCHAN_WEAPON,SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL)
}
